type weatherType {
  id: ID!
  coord: coordType
  weather: [mainWeatherType]
  base: String
  main: mainType
  visibility: Float
  wind: windType
  clouds: cloudsType
  datetime: Float
  sys: sysType
  name: String
}

type coordType {
  latitude: Float
  longitude: Float
}

type mainWeatherType {
  id: ID!
  main: String
  description: String
  icon: String
}

type mainType {
  tempink: Float
  tempinc: Float
  tempinf: Float
  pressure: Float
  humidity: Float
  tempmin: Float
  tempmax: Float
}

type windType {
  speed: Float
  degree: Float
}

type cloudsType {
  all: Int
}

type sysType {
  type: Int
  id: Int
  message: Float
  country: String
  sunrise: Float
  sunset: Float
}

type timeType {
  id: ID!
  weeknumber: Int
  utcoffset: String
  unixtime: String
  timezone: String
  dstuntil: String
  dstfrom: String
  dst: Boolean
  dayofyear: Int
  dayofweek: Int
  datetime: String
  abbreviation: String
}

type promotionType {
  id: ID!
  nodeid: ID
  title: String
  description: String
  image: [imageType]
}

type openingHoursType {
  sunday: String
  monday: String
  tuesday: String
  wednesday: String
  thursday: String
  friday: String
  saturday: String
}

type nodeType {
  id: ID!
  name: String
  type: String
  coordinate: coordinateType
  floor: floorType
  details: nodeDetailsType
}

type nodeDetailsType {
  description: String
  logoid: ID
  imageid: ID
  location: String
  category: String
  openinghours: openingHoursType
  image: imageType
  logo: imageType
}

type imageType {
  id: ID!
  length: Float
  chunksize: Float
  uploaddate: String
  filename: String
  data: String
}

type floorType {
  id: ID!
  name: String
}

type coordinateType {
  x: String
  y: String
  z: String
}

type buildingType {
  id: ID!
  name: String
  location: String
  description: String
  image: [imageType]
}

type Query {
  stores(floor: String!): [nodeType]
  floors: [floorType]
  getStore(id: String!): nodeType
  search(query: String): [nodeType]
  getImage(id: ID!): imageType
  getWeather(locale: String!): weatherType
  getCurrentTime(timezone: String!): timeType
  getBuildingInfo: buildingType
  getActivePromotions: [promotionType]
  getPath(destination: ID!): [nodeType]
}

type Mutation {
  addStore(name: String!, type: String!, floor: ID!): nodeType
  deleteStore(id: ID!): nodeType
}
